package dev.ninjdai.werewolf.commands;

import dev.ninjdai.werewolf.uhc.UHCPlayer;
import dev.ninjdai.werewolf.uhc.roles.Roles;
import net.minestom.server.command.builder.Command;
import net.minestom.server.command.builder.arguments.ArgumentEnum;
import net.minestom.server.command.builder.arguments.ArgumentType;
import net.minestom.server.command.builder.arguments.ArgumentEnum.Format;
import net.minestom.server.entity.GameMode;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public class GamemodeCommand extends Command {
    static final ArgumentEnum<GameMode> gamemodeArgument = ArgumentType.Enum("gamemode", GameMode.class).setFormat(Format.LOWER_CASED);
    public GamemodeCommand() {
        super("gamemode", "gm");

        setDefaultExecutor((sender, context) -> {
            sender.sendMessage("LG UHC");
        });

        addSyntax((sender, context) -> {
            if(! (sender instanceof UHCPlayer player)) return;
            player.setGameMode(context.get(gamemodeArgument));
        }, gamemodeArgument);
    }
}
