package dev.ninjdai.werewolf.worldgen;

import dev.ninjdai.werewolf.worldgen.noises.InterpolatedNoises;
import dev.ninjdai.werewolf.worldgen.noises.Noises;

public class LGTerrainBuilder extends TerrainBuilder {
    // 0: no squashing the terrain, 1: basically the surface height
    private final double squashingFactor = 1.5;


    public LGTerrainBuilder(long seed) {
        super(seed);
    }

    @Override
    public int getSurfaceHeight(int x, int z) {
        double continentalness = InterpolatedNoises.CONTINENTALNESS.evaluateNoise(x, z);
        double erosion = InterpolatedNoises.EROSION.evaluateNoise(x, z);

        return (int) ((continentalness + erosion) * 50);
    }

    @Override
    public double getDensity(int x, int y, int z) {
        double density = Noises.DENSITY.evaluateNoise(x, y, z);
        int surfaceHeight = getSurfaceHeight(x, z);

        density *= (double) surfaceHeight / y;

        return density;
    }
}
