package dev.ninjdai.werewolf.worldgen;

import it.unimi.dsi.fastutil.doubles.DoubleArrayList;
import it.unimi.dsi.fastutil.doubles.DoubleList;
import net.minestom.vanilla.datapack.worldgen.math.SplineInterpolator;

public class SplineInterpolatorBuilder {
    private DoubleList xList;
    private DoubleList yList;

    public SplineInterpolatorBuilder() {
        this.xList = new DoubleArrayList();
        this.yList = new DoubleArrayList();
    }

    public SplineInterpolatorBuilder add(double x, double y) {
        this.xList.add(x);
        this.yList.add(y);
        return this;
    }

    public SplineInterpolator build() {
        return SplineInterpolator.createMonotoneCubicSpline(xList, yList);
    }
}
