package dev.ninjdai.werewolf.worldgen.noises;

import de.articdive.jnoise.generators.noisegen.perlin.PerlinNoiseGenerator;
import de.articdive.jnoise.pipeline.JNoise;
import net.minestom.server.registry.DynamicRegistry;
import net.minestom.server.world.biome.Biome;

public enum BiomeNoises {
    HUMIDITY(JNoise.newBuilder()
            .perlin(PerlinNoiseGenerator.newBuilder()
                    .setSeed(0)
                    .build())
            .scale(0.0015)
            .build());

    final private JNoise noise;

    BiomeNoises(JNoise noise) {
        this.noise = noise;
    }

    public double evaluateNoise(int x, int z) {
        return noise.evaluateNoise(x, z);
    }

    public double evaluateNoise(int x, int y, int z) {
        return noise.evaluateNoise(x, y, z);
    }
}
