package dev.ninjdai.werewolf.worldgen.noises;

import de.articdive.jnoise.generators.noisegen.opensimplex.FastSimplexNoiseGenerator;
import de.articdive.jnoise.generators.noisegen.perlin.PerlinNoiseGenerator;
import de.articdive.jnoise.generators.noisegen.random.white.WhiteNoiseGenerator;
import de.articdive.jnoise.modules.octavation.fractal_functions.FractalFunction;
import de.articdive.jnoise.pipeline.JNoise;
import dev.ninjdai.werewolf.worldgen.utils.AbsClampNoiseModifier;

public enum Noises {
    WEIRDNESS(JNoise.newBuilder()
            .fastSimplex(FastSimplexNoiseGenerator.newBuilder()
                    .setSeed(0)
                    .build())
            .octavate(5, 0.5, 1.2, FractalFunction.FBM, false)
            .scale(0.005)
            .addModifier(new AbsClampNoiseModifier())
            .build()),
    DENSITY(JNoise.newBuilder()
            .fastSimplex(FastSimplexNoiseGenerator.newBuilder()
                    .setSeed(0)
                    .build())
            .octavate(5, 0.7, 1.6, FractalFunction.FBM, true)
            .scale(0.006)
            .addModifier(new AbsClampNoiseModifier())
            .build()),

    FEATURES(JNoise.newBuilder()
            .white(WhiteNoiseGenerator.newBuilder().setSeed(0).build())
            .addModifier(new AbsClampNoiseModifier())
            .build()),

    ROOFED(JNoise.newBuilder()
            .perlin(PerlinNoiseGenerator.newBuilder()
                    .setSeed(0)
                    .build())
            .scale(0.1)
            .addModifier(new AbsClampNoiseModifier())
            .build());

    final private JNoise noise;

    Noises(JNoise noise) {
        this.noise = noise;
    }

    public double evaluateNoise(int x, int z) {
        return noise.evaluateNoise(x, z);
    }

    public double evaluateNoise(int x, int y, int z) {
        return noise.evaluateNoise(x, y, z);
    }
}